#ifndef CELL_H
#define CELL_H

#include "ScalarField.h"
#include <types.h>

typedef struct {
	ScalarFieldVertex*	verts[2];
} CellEdge;

typedef struct {
	ScalarFieldVertex*	verts[8];
} Cell;

typedef struct {
	uint8_t	a, b;
} uint8_tPair;

void init_Cell( Cell* self, ScalarField const* scalarField, uint16_t i, uint16_t j, uint16_t k );

static inline CellEdge getEdge_Cell( Cell const* self, uint8_t edgeIndex ) {

	static const uint8_tPair edges[] = {
		{ 0, 1 },	// 0
		{ 1, 2 },	// 1
		{ 2, 3 },	// 2
		{ 3, 0 },	// 3
		{ 4, 5 },	// 4
		{ 5, 6 },	// 5
		{ 6, 7 },	// 6
		{ 7, 4 },	// 7
		{ 0, 4 },	// 8
		{ 1, 5 },	// 9
		{ 2, 6 },	// A
		{ 3, 7 }	// B
	};

	return (CellEdge) {
		.verts[0] = self->verts[ edges[ edgeIndex ].a ],
		.verts[1] = self->verts[ edges[ edgeIndex ].b ]
	};
}

#endif	/* CELL_H */
