OUTPUT_FORMAT("elf32-bigmips")
OUTPUT_ARCH(mips)

EXTERN(__init)
ENTRY(__init)

MEMORY {
	/*REGION_RAM (rwx)		: ORIGIN = 0x80000000, LENGTH = 4M*/
	REGION_RAM_LOAD (rwx)	: org = 0x80000400, len = (0x100000-0x400)
	/*REGION_ROM (rx)			: ORIGIN = 0x00000000, LENGTH = 4M*/
	REGION_ROM_GFX (rwx)	: org = 0x90100000, len = 3M
}

/* TODO: alignments */
SECTIONS {
	__text_start = .;
	.text : {
		*(.initialization)
		*(.text) *(.text.*) *(.MIPS.abiflags)
	} > REGION_RAM_LOAD

	.sdata BLOCK(16) : { 
		_gp = .;	/*ALIGN(16);*/
		*(.sdata)
	} > REGION_RAM_LOAD

	.scommon BLOCK(16) : {
		__bss_start = .;
		*(.scommon)
	} > REGION_RAM_LOAD

	.sbss : {
		*(.sbss)
	} > REGION_RAM_LOAD

	ASSERT((. - _gp) < 32767, "sbss exceeds limit")

	.bss : {
		*(.bss)
	} > REGION_RAM_LOAD
	__bss_end = .;

	.rodata : {
		*(.rodata) *(.rodata.*)
		/**(EXCLUDE_FILE(CMakeFiles/prog.elf.dir/models/cpu.c.obj) *.rodata*)*/
	} > REGION_RAM_LOAD

	.data : {
		__data_start = .;
		*(
			EXCLUDE_FILE(CMakeFiles/prog.elf.dir/models/*.c.obj sound.o)
			*.data*
		)
		*(COMMON)
		SHORT(0xDEAD)
		SHORT(0xBEEF)
	} > REGION_RAM_LOAD = 0xFE
	__data_end = .;

	.fill1 : {
		. = ORIGIN(REGION_RAM_LOAD) + LENGTH(REGION_RAM_LOAD) - 0x1000 - 2;
		SHORT(0xBAAF);
	} > REGION_RAM_LOAD = 0xBEEF
	__fill_end = .;

	.models : AT(__fill_end) /*SUBALIGN(0x10)*/ {
		. = ORIGIN(REGION_ROM_GFX) + 0x100000 - 2;
		SHORT(0xDADA);
	} > REGION_ROM_GFX = 0xDEDE
	__models_end = .;

	.fill2 : AT(0x80200400) {
		KEEP(CMakeFiles/prog.elf.dir/models/*.c.obj(*.data*))
		KEEP(sound.o(*.data*))
		. = ORIGIN(REGION_ROM_GFX) + LENGTH(REGION_ROM_GFX) - 2;
		SHORT(0xBABA);
	} > REGION_ROM_GFX /*AT> REGION_ROM_GFX*/ = 0xBEBA

	/DISCARD/ : {
		*(*)
	}

	__heap_start = 0x80300000 + 320*240*2;
	__heap_end = 0x80800000 - 8192;
}
