#ifndef  ACTMGR_H
#define  ACTMGR_H

#include "action.h"
#include <containers/vec_.h>
#include <sys/region.h>

#define	ACTMGR_TIME_INFINITY { -1, -1, -1 }

typedef struct {
	Vec actions;
} ActMgr;

static inline void init_ActMgr( ActMgr* self ) {
	self->actions = create_Vec( sizeof(Action), Default_RegionAlignment, destroy_Action_void );
}

static inline ActMgr create_ActMgr( void ) {
	ActMgr retval;
	init_ActMgr( &retval );

	return retval;
}

static inline void destroy_ActMgr( ActMgr* self ) {
	destroy_Vec( &self->actions );
}

static inline size_t addAction_ActMgr( ActMgr* self, Action action ) {
	size_t actionId = getLength_Vec( &self->actions );
	pushBack_Vec( &self->actions, &action );

	return actionId;
}

static inline void* getActionContext_ActMgr( ActMgr const* self, size_t const actionId ) {
	return ((Action const*)getConstElement_Vec( &self->actions, actionId ))->context;
}

void process_ActMgr( ActMgr* actmgr, Time const* timeCurrent );
void detachAction_ActMgr( ActMgr* actmgr, Action* action );

#endif   /* ACTMGR_H */
