#ifndef ITERATOR_EXT_H
#define ITERATOR_EXT_H

#include <containers/iterator.h>
#include <containers/object.h>
#include <containers/vec_.h>

static inline Vec filter_IteratorConst( IteratorConst* self, bool predicate_func( void const* ) ) {
	Vec filtered = create_Vec( sizeof(void const*), Default_RegionAlignment, NULL );
	void const* element_ptr;
	while( (element_ptr = next_IteratorConst( self )) ) {
		true == predicate_func( element_ptr ) ?
			(void)pushBack_Vec( &filtered, &element_ptr ) :
			(void)NULL;
	}

	//destroy_IteratorConst( self );

	return filtered;
}

static inline Vec map_IteratorConst( IteratorConst* self, Object const* dest_obj_desc, void map_func( void* dest, void const* src ) ) {
	Vec mapped = create_Vec( dest_obj_desc->size_of, dest_obj_desc->alignment, NULL );

	void const* element_ptr;
	while( (element_ptr = next_IteratorConst( self )) ) {
		pushBack_Vec( &mapped, element_ptr );
		map_func( getLast_Vec( &mapped ), element_ptr );
	}

	//destroy_IteratorConst( self );

	return mapped;
}

#endif	/* ITERATOR_EXT_H */
