#ifndef STACK_H
#define STACK_H

#include <containers/vec_.h>
#include <types.h>

typedef struct {
	size_t	el_size;
	uint_t	el_pushed;
	Vec		data;
} Stack;

void init_Stack( Stack* self, size_t el_size, void (*destroy_func)(void*) );
void destroy_Stack( Stack* self );
void push_Stack( Stack* self, void* element );
void* pop_Stack( Stack* self );
void* get_Stack( Stack* self, uint_t i );
bool isEmpty_Stack( Stack const* self );
void reset_Stack( Stack* self );

#endif	/* STACK_H */

