#ifndef MATH_H
#define MATH_H

#include <types.h>
//#include "matrix.h"
//#include "vector.h"

#define RAND_MAX	0x7FFF

float atan2f( float y, float x );
double atan2( double y, double x );
float sqrtf( float );
float sinf( float );
uint8_t log2uint( uint32_t val );
bool log2_has_frac( uint32_t val );
int rand( void );

static inline int signum( float x ) {
	return
		(x < 0) ? -1 :
		(x == 0) ? 0 : 1;
}

static inline float fabsf( float x ) {
	return (x >= 0) ? x : -x;
}

static inline float fminf( float x, float y ) {
	return (x <= y) ? x : y;
}

static inline float fmaxf( float x, float y ) {
	return (x > y) ? x : y;
}

static inline float rad_to_deg( float const angle ) {
	return (180 / M_PI) * angle;
}

static inline bool is_odd_uint( uint_t const value ) {
	return value & 0x1;
}

static inline bool is_even_uint( uint_t const value ) {
	return !is_odd_uint( value );
}

//void transformVector_Math( Vector3f* out, Vector3f* vec, Matrix* mtx );

#endif	/* MATH_H */

