#ifndef MEMPOOL_H
#define MEMPOOL_H

#include <sys/region.h>
#include <types.h>

#define MEMPOOL_MAX_ENTRIES (256)
#define MEMPOOL_ALLOC_MAP_TYPE uint32_t
#define MEMPOOL_ALLOC_MAP_ENTRY_BITS (32)
#define MEMPOOL_ALLOC_MAP_ENTRIES (MEMPOOL_MAX_ENTRIES / sizeof(MEMPOOL_ALLOC_MAP_TYPE))

typedef struct {
	void* data;
	void* data_aligned;
	uint32_t alloc_map[MEMPOOL_ALLOC_MAP_ENTRIES];
	uintptr_t adr_step;
	uintptr_t adr_step_scaled;
} MemPool;

void init_MemPool( MemPool* self, size_t const el_size, size_t const num_el, RegionAlignment const alignment );
void destroy_MemPool( MemPool* self );
void* allocate_MemPool( MemPool* self );
void return_MemPool( MemPool* self, void const* handle );

#endif	/* MEMPOOL_H */
