#ifndef RECTANGLE_H
#define RECTANGLE_H

typedef struct {
	uint16_t p0x, p0y;
	uint16_t p1x, p1y;
} Rectangle;

#define RECTANGLE_INIT(p0x, p0y, p1x, p1y) \
{ p0x, p0y, p1x, p1y }

static inline uint16_t getWidth_Rectangle( Rectangle const* self ) {
	return (self->p1x - self->p0x) + 1;
}

static inline uint16_t getHeight_Rectangle( Rectangle const* self ) {
	return (self->p1y - self->p0y) + 1;
}

static inline uint32_t getArea_Rectangle( Rectangle const* self ) {
	return getWidth_Rectangle( self ) * getHeight_Rectangle( self );
}

#endif	/* RECTANGLE_H */

