#ifndef AUDIODEVICE_H
#define AUDIODEVICE_H

#include <types.h>

#define AI_THREAD_STACK_SIZE		0x2000

typedef struct {
	uint32_t	playbackRate;
	void const*	sourceStart;
	void const* sourceCurrent;
	void*		outputBuffer[2];
	uint_t		currentOutputBufferIndex;	// buffer where we write
	size_t		outputBufferSize;
	OSMesgQueue	aiMessageQ;
	OSMesg		aiMessages;
	OSThread	aiThread;
	u64			aiThreadStack[AI_THREAD_STACK_SIZE / sizeof(u64)];
} AudioDevice;

void init_AudioDevice( AudioDevice* self, uint32_t const playbackRate, void* outputBuffer0, void* outputBuffer1, size_t const outputBufferSize );
uint32_t getPlaybackRate_AudioDevice( AudioDevice const* self );
void setPlaybackRate_AudioDevice( AudioDevice* self, uint32_t const rate );
void const* getSource_AudioDevice( AudioDevice const* self );
void setSource_AudioDevice( AudioDevice* self, void const* source );
void sendBufferToOutput_AudioDevice( AudioDevice const* self );

#endif	/* AUDIODEVICE_H */
