#ifndef MICROCODE_H
#define MICROCODE_H

typedef enum {
	F3DEX2_MicrocodeId,
	L3DEX2_MicrocodeId
} MicrocodeId;

typedef struct {
	MicrocodeId	id;
	OSTask_t	tlist;
} Microcode;

static inline Microcode create_Microcode( MicrocodeId const id, u64* ucode, u64* ucode_data ) {
	return (Microcode) {
		.id = id,
		.tlist = (OSTask_t) {
			.type				= M_GFXTASK,
			.flags				= OS_TASK_DP_WAIT,
			.ucode_size			= SP_UCODE_SIZE,
			.ucode_data_size	= SP_UCODE_DATA_SIZE,
			.dram_stack			= NULL,
			.dram_stack_size	= SP_DRAM_STACK_SIZE8,
			.ucode				= ucode,
			.ucode_data			= ucode_data,
			.ucode_boot			= (u64*)rspbootTextStart,
			.ucode_boot_size	= (u32)rspbootTextEnd - (u32)rspbootTextStart,
			.data_ptr			= NULL,
			.data_size			= NULL,
			.output_buff		= NULL,
			.output_buff_size	= 0,
			.yield_data_ptr		= NULL,
			.yield_data_size	= OS_YIELD_DATA_SIZE
		}
	};
}

#endif	/* MICROCODE_H */
