#ifndef	DISPLAYLIST_H
#define	DISPLAYLIST_H

#include <ultra64.h>
#include <types.h>
#include <containers/vec_.h>
#include <sys/region.h>

/* structures */
typedef struct {
	Vec	gfx;
} NativeDL;

/* interface */
NativeDL* new_NativeDL( void );

static inline void init_NativeDL( NativeDL* self ) {
	init_Vec( &self->gfx, sizeof(Gfx), B8_RegionAlignment, NULL );
}

static inline Gfx* getHead_NativeDL( NativeDL* self ) {
	return getElement_Vec( &self->gfx, 0 );
}

static inline size_t getLength_NativeDL( NativeDL const* self ) {
	return getLength_Vec( &self->gfx );
}

static inline size_t getSizeInBytes_NativeDL( NativeDL const* self ) {
	return getSizeInBytes_Vec( &self->gfx );
}

static inline void resetCounter_NativeDL( NativeDL* self ) {
	reset_Vec( &self->gfx );
}

static inline void addCommand_NativeDL_( NativeDL* self, Gfx cmd ) {
	pushBack_Vec( &self->gfx, &cmd );
}

static inline void addCommands_NativeDL_( NativeDL* self, Gfx cmd[], size_t n ) {
	for( size_t i=0; i<n; ++i ) {
		addCommand_NativeDL_( self, cmd[i] );
	}
}

bool isOverflowed_NativeDL( NativeDL* self );

#define addCommand_NativeDL(dl, cmd)						\
{									\
	Gfx commands[] = {cmd};						\
	addCommands_NativeDL_(dl, commands, sizeof(commands)/sizeof(Gfx));	\
}

#endif   /* DISPLAYLIST_H */

