#ifndef REGION_H
#define REGION_H

#include <types.h>

typedef enum RegionAlignment {
	B1_RegionAlignment = 0,
	B2_RegionAlignment = 1,
	B4_RegionAlignment = 2,
	B8_RegionAlignment = 3,
	B16_RegionAlignment = 4,
	B32_RegionAlignment = 5,
	B64_RegionAlignment = 6,
	Default_RegionAlignment = B4_RegionAlignment
} RegionAlignment;

static inline bool isAddressAligned( void const* address, RegionAlignment const alignment ) {
	return 0 == ((uintptr_t)address & ((1 << alignment) - 1));
}

#endif

