#ifndef SYS_H
#define SYS_H

#include "audiodevice.h"
#include "dlist.h"
#include "gfxdevice.h"
#include "surface.h"
#include "time.h"
#include "types.h"

typedef void (*handler_f)( void* sys_arg, void* userArg );

typedef enum {
	Vbi_HandlerType_Sys,
	Controller_HandlerType_Sys
} HandlerType_Sys;

int				init_Sys( void );
void			raiseError_Sys( void );
void			registerHandler_Sys( HandlerType_Sys const type, handler_f handler, void* userArg );
Time			getTime_Sys( void );
void			performDma_Sys( void* dest, void const* src, size_t const size );
GfxDevice*		getGfxDevice_Sys( void );
AudioDevice*	getAudioDevice_Sys( void );
void*			getHiMem_Sys( void );

#endif

