#ifndef TIME_H
#define TIME_H

#include <types.h>

typedef struct {
	int64_t	sec;
	int32_t	msec;
	int32_t	nsec;
} Time;

typedef enum {
	TIME_LESS,
	TIME_EQUAL,
	TIME_GREATER
} TimeRelation;

static inline Time add_Time( Time const* t0, Time const* t1) {
	return (Time) {
		.sec = t0->sec + t1->sec,
		.msec = t0->msec + t1->msec,
		.nsec = t0->nsec + t1->nsec
	};
}

static inline Time calcDuration_Time( Time const* t0, Time const* t1) {
	return (Time) {
		.sec = t1->sec - t0->sec,
		.msec = t1->msec - t0->msec,
		.nsec = t1->nsec - t0->nsec
	};
}

static inline int64_t asMilliseconds_Time( Time const* time ) {
	return time->sec * 1000 + time->msec;
}

TimeRelation compare_Time( Time const* t0, Time const* t1 );

#endif	/* TIME_H */

