#ifndef TEXTUREGENERATOR_H
#define TEXTUREGENERATOR_H

#include <myheader.h>
#include <texture.h>

static inline float radial_func( float const xNormalized, float const yNormalized ) {
	return fmaxf(
		1.0f - 2.0f*
			sqrtf(
				(xNormalized - 0.5f) * (xNormalized - 0.5f) +
				(yNormalized - 0.5f) * (yNormalized - 0.5f)
			)
		, 0.0f
	);
}

static inline float plasma_func( float const xNormalized, float const yNormalized ) {
	return fmaxf(
		0.25f * (
			(1.0f + sinf( 16 * M_PI * xNormalized )) +
			(1.0f + cosf( 16 * M_PI * yNormalized ))
		)
		, 0.0f
	);
}

Texture generate_texture( size_t const width, size_t const height, TextureFormat const format, float func( float, float ) );

#endif	/* TEXTUREGENERATOR_H */
