#include <abort.h>
#include "actmgr/actmgr.h"

/*
void addAction_ActMgr( ActMgr* self, Action* action ) {
	bool foundEmpty = false;

	VecIterator actions = createIterator_Vec( &self->actions, (IteratorRange) { .type = ITERATORRANGE_ALL } );
	for( Action** current_action; (current_action = next_VecIterator( &actions )); ) {
		if( NULL == *current_action ) {
			*current_action = action;
			foundEmpty = true;
			break;
		}
	}
	destroy_VecIterator( &actions );

	if( false == foundEmpty ) {
		pushBack_Vec( &self->actions, &action );
	}
}
*/

void process_ActMgr( ActMgr* self, Time const* timeCurrent ) {
	static Time const timeInf = ACTMGR_TIME_INFINITY;

	VecIterator actions = createIterator_Vec( &self->actions, (IteratorRange) { .type = All_IteratorRange } );
	Action *action;
	while( (action = next_VecIterator( &actions )) ) {
		if( TIME_LESS == compare_Time( timeCurrent, &action->timeStart ) ) {
			continue;
		}

		Time const timeFromStart = calcDuration_Time( &action->timeStart, timeCurrent );

		if( TIME_EQUAL == compare_Time( &action->timeDuration, &timeInf ) ||
			TIME_LESS == compare_Time( &timeFromStart, &action->timeDuration )
		) {
			if( false == action->initialized ) {
				action->context = action->initFunc( &timeFromStart, &action->timeDuration, action->arg );
				action->initialized = true;
			}

			if( action->processFunc ) {
				action->processFunc( action->context, &timeFromStart, action->arg );
			}
		} else {
			//detachAction_ActMgr( self, action );
			if( action->initialized ) {
				action->destroyFunc( action->context, action->arg );
			}
			action->initialized = false;
		}
	}
	destroy_VecIterator( &actions );
}

void detachAction_ActMgr( ActMgr* self, Action* action ) {
	if( self ) {}
	if( action ) {}
	abort();
}

