#include <abort.h>
#include <containers/tree.h>

TreeNode cloneRecursive_TreeNode( TreeNode const* self, void* (*clone_func)(void const*) ) {
	abort();
	TreeNode cloned = create_TreeNode( self->data, self->children.base.destroy_func, NULL, 0 );

	VecConstIterator iter = createConstIterator_Vec( &self->children, (IteratorRange) { .type = All_IteratorRange } );
	TreeNode const* child;
	while( (child = next_VecConstIterator( &iter )) ) {
		attachChild_TreeNode( &cloned,
			cloneRecursive_TreeNode( child, clone_func )
		);
	}
	destroy_VecConstIterator( &iter );

	return cloned;
}

inline void destroy_Tree( Tree* self ) {
	TreeNodeIterator iter = create_TreeNodeIterator( &self->root );
	for( TreeNode const* node; (node = inc_TreeNodeIterator( &iter )); ) {
		if( self->destroy_func ) { self->destroy_func( node ); }
		destroy_TreeNode( node );
	}
	destroy_TreeNodeIterator( &iter );
}

inline Tree clone_Tree( Tree const* self ) {
	if( self ) {}
	abort();
	Tree cloned;
	return cloned;
}

TreeNode const* inc_TreeNodeIterator( TreeNodeIterator* self ) {
	bool node_visited;
	TreeNode const* node;
	do {
		if( NULL == (node = self->next) ) {
			return NULL;
		}

		node_visited = (self->i != 0);

		size_t const num_children = getNumChildren_TreeNode( node );
		if( self->i < num_children ) {
			self->next = getChild_TreeNode( node, self->i );
			++self->i;
			push_Stack( &self->stack, &self->i );
			push_Stack( &self->parent, &node );				// TEMP

			self->i = 0;
		} else {
			if( true == isEmpty_Stack( &self->stack ) ) {
				return (0 != num_children) ?
					NULL :
					(self->next = NULL, self->node);		// it was a single-node tree
			}
		
			self->i = *(size_t*)pop_Stack( &self->stack );
			self->next = *(TreeNode**)pop_Stack( &self->parent );
		}
	} while( node_visited );

	return node;
}

