#include <math/matrix.h>

void invert_Matrix( Matrix const* restrict mi, Matrix* restrict mtxout ) {
	float det = MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 3)
		  + MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 1)
		  + MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 2)
		  + MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 2)
		  
		  + MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 3)
		  + MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 0)
		  + MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 3)
		  + MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 0)
		  
		  + MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 1)
		  + MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 1)
		  + MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 2)
		  + MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 0)
		  
		  - MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 2)
		  - MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 3)
		  - MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 1)
		  - MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 3)
		  
		  - MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 0)
		  - MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 2)
		  - MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 1)
		  - MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 3)
		  
		  - MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 0)
		  - MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 2)
		  - MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 0)
		  - MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 1);
	
	MATRIX_GET(*mtxout, 0, 0) = ( MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 1)
			+ MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi ,3, 2)
			- MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 1) ) / det;

	MATRIX_GET(*mtxout, 0, 1) = ( MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 2)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 2) ) / det;

	MATRIX_GET(*mtxout, 0, 2) = ( MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 3, 1)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 3, 1) ) / det;

	MATRIX_GET(*mtxout, 0, 3) = ( MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 2)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 3)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 1)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 3)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 1)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 2) ) / det;

	MATRIX_GET(*mtxout, 1, 0) = ( MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 2)
			+ MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 2) ) / det;

	MATRIX_GET(*mtxout, 1, 1) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 0)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 0) ) / det;

	MATRIX_GET(*mtxout, 1, 2) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 3, 2)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 3, 2) ) / det;

	MATRIX_GET(*mtxout, 1, 3) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 3)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 0)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 2)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 2)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 3)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 0) ) / det;

	MATRIX_GET(*mtxout, 2, 0) = ( MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 0)
			+ MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 0) ) / det;

	MATRIX_GET(*mtxout, 2, 1) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 1)
			+ MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 2, 3)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 1) ) / det;

	MATRIX_GET(*mtxout, 2, 2) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 3, 3)
			+ MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 3, 0)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 3, 3)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 3, 0) ) / det;

	MATRIX_GET(*mtxout, 2, 3) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 1)
			+ MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 3)
			+ MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 0)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 3)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 3)*MATRIX_GET(*mi, 2, 0)
			- MATRIX_GET(*mi, 0, 3)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 1) ) / det;

	MATRIX_GET(*mtxout, 3, 0) = ( MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 1)
			+ MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 2)
			+ MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 1) ) / det;

	MATRIX_GET(*mtxout, 3, 1) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 2)
			+ MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 0)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 2, 2)*MATRIX_GET(*mi, 3, 1)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 2, 0)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 2, 1)*MATRIX_GET(*mi, 3, 0) ) / det;

	MATRIX_GET(*mtxout, 3, 2) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 3, 1)
			+ MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 3, 2)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 3, 2)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 3, 0)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 3, 1) ) / det;

	MATRIX_GET(*mtxout, 3, 3) = ( MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 2)
			+ MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 0)
			+ MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 1)
			- MATRIX_GET(*mi, 0, 0)*MATRIX_GET(*mi, 1, 2)*MATRIX_GET(*mi, 2, 1)
			- MATRIX_GET(*mi, 0, 1)*MATRIX_GET(*mi, 1, 0)*MATRIX_GET(*mi, 2, 2)
			- MATRIX_GET(*mi, 0, 2)*MATRIX_GET(*mi, 1, 1)*MATRIX_GET(*mi, 2, 0) ) / det;
}
