#include <mesh.h>

Mesh clone_Mesh( Mesh const* self ) {
	Mesh clonedMesh = create_Mesh();

	setOpacity_Mesh( &clonedMesh,
		getOpacity_Mesh( self )
	);
	setAttributes_Mesh( &clonedMesh,
		getAttributes_Mesh( self )
	);

	VecConstIterator layers = createLayerConstIterator_Mesh( self );
	for( Layer const* layer; (layer = (Layer const*)next_VecConstIterator( &layers )); ) {
		Layer clonedLayer = clone_Layer( layer );
		addLayer_Mesh( &clonedMesh, clonedLayer );
	}
	destroy_VecConstIterator( &layers );

	return clonedMesh;
}

inline void reset_Mesh( Mesh* self ) {
	VecIterator iterator = createIterator_Vec( &self->layers, (IteratorRange) { .type = All_IteratorRange } );
	for( Layer* layer; (layer = (Layer*)next_VecIterator( &iterator )); ) {
		reset_Layer( layer );
	}
	destroy_VecIterator( &iterator );
}
