#include <abort.h>
#include <string.h>
#include <node/camera.h>

void init_Camera( Camera* self, CameraType const type ) {
	self->type = type;
	switch( type ) {
		case Perspective_CameraType: {
			setParams_PerspCamera( getPersp_Camera( self ), 63.74f, 1.33f, 1000.0f );
			break;
		}
		case Orthographic_CameraType: {
			setParams_OrthoCamera( getOrtho_Camera( self ), -160.0f, 160.0f, -120.0f, 120.0f, 1.33f, 1000.0f );
			break;
		}
		default: {
			abort();
		}
	}
}

void destroy_Camera( Camera* self ) {
	if( self ) {}
}

