#include <string.h>
#include <node/xformer.h>

void finish_Xformer( Xformer* xf, Xformer* parentXf, Matrix* resultMatrix ) {
	xf->resultMtx = resultMatrix;

	if( parentXf ) {
		multiply_Matrix(
			getResultMatrix_Xformer( xf ),
			getMatrix_Xformer( xf ),
			getResultMatrix_Xformer( parentXf )
		);
	} else {
		memcpy(
			getResultMatrix_Xformer( xf ),
			getMatrix_Xformer( xf ),
			sizeof( Matrix )
		);
	}

	Matrix const* finalMatrix = getResultMatrix_Xformer( xf );
	Coordsys* coordSystem = getCoordsys_Xformer( xf );
	coordSystem->origin = create_Vector3f(
		MATRIX_GET( *finalMatrix, 3, 0 ),
		MATRIX_GET( *finalMatrix, 3, 1 ),
		MATRIX_GET( *finalMatrix, 3, 2 )
	);
	coordSystem->n = create_Vector3f(
		MATRIX_GET( *finalMatrix, 2, 0 ),
		MATRIX_GET( *finalMatrix, 2, 1 ),
		MATRIX_GET( *finalMatrix, 2, 2 )
	);
}
