#include <string.h>
#include <node/xformer_funcs.h>

void processBillboard_Xformer( struct Xformer* billboardXf, void* data ) {
	Xformer const* cameraXf = data;
	Vector3f const cn = getCoordsysConst_Xformer( cameraXf )->n;

	Matrix align;
	align_Matrix( &align, 0.0f, -cn.x, -cn.y, -cn.z );

	Vector3f const billboardPosition = getCoordsys_Xformer( (Xformer*)billboardXf )->origin;
	Matrix* finalMatrix = getResultMatrix_Xformer( (Xformer const*)billboardXf );
	translate_Matrix( finalMatrix, billboardPosition.x, billboardPosition.y, billboardPosition.z );

	multiply_Matrix( finalMatrix, &align, finalMatrix );
}

void processCamera_Xformer( struct Xformer* cameraXf, void* data ) {
	if( data ) {}

	memcpy(
		getResultMatrix_Xformer( (Xformer*)cameraXf ),
		getMatrix_Xformer( (Xformer*)cameraXf ),
		sizeof(Matrix)
	);
	reset_Xformer( (Xformer*)cameraXf );
}

void processSkybox_Xformer( struct Xformer* skyboxXf, void* data ) {
	Xformer const* cameraXf = (Xformer const*)data;
	Matrix* cameraMatrix = getResultMatrix_Xformer( cameraXf );

	Matrix* finalMatrix = getResultMatrix_Xformer( (Xformer const*)skyboxXf );
	MATRIX_GET( *finalMatrix, 3, 0 ) = MATRIX_GET( *cameraMatrix, 3, 0 );
	//MATRIX_GET( *finalMatrix, 3, 1 ) = MATRIX_GET( *cameraMatrix, 3, 1 );
	MATRIX_GET( *finalMatrix, 3, 2 ) = MATRIX_GET( *cameraMatrix, 3, 2 );
}
