#include "textureGenerator.h"

Texture generate_texture( size_t const width, size_t const height, TextureFormat const format, float func( float, float ) ) {

	uint16_t* const pixels = malloc( width * height * getBytesPerPixel_TextureFormat( format ) );

	void* pixelsIterator = pixels;
	float const dx = 1.0f / width, dy = 1.0f / height;
	float yNormalized = 0.0f;
	for( size_t y=0; y<height; ++y, yNormalized += dy ) {
		float xNormalized = 0.0f;
		for( size_t x=0; x<width; ++x, xNormalized += dx ) {
			float const value = func( xNormalized, yNormalized );
			switch( format ) {
				case Rgba16_TextureFormat: {
					uint16_t const shade = 31 * value;
					*(uint16_t*)pixelsIterator = (shade << 11) | (shade << 6) | (shade << 1) | 0x1;
					pixelsIterator = 1 + (uint16_t*)pixelsIterator;
					break;
				};
				default: abort();
			}
		}
	}

	return create_Texture( width, height, new_Shared( pixels ), NULL, 0, format );
}

