#include "clear_action.h"
#include "main.h"

typedef struct {
	Engine*		engine;
	Vector3f	clearColor;
	float		clearZ;
} Context;

void* init_clear_action( Time const* timeFromStart, Time const* timeDuration, void* arg ) {
	if( timeFromStart ) {}
	if( timeDuration ) {}

	ClearActionArgs const* args = arg;
	Context* context = malloc( sizeof(*context) );
	*context = (Context) {
		.engine		= args->engine,
		.clearColor	= args->clearColor,
		.clearZ		= args->clearZ
	};

	return context;
}

void destroy_clear_action( void* context_generic, void* arg ) {
	if( arg ) {}
	free( context_generic );
}

void handle_clear_action( void* context_generic, Time const* time, void* arg ) {
	if( time ) {}

	Context* context = context_generic;
	Engine* engine = context->engine;
	ClearActionArgs* args = arg;

	// NOTE: The order is important at the moment - DLTrans seems to be messed
	// (see notes about gDPSetDepthImage in Nintendo manual)
	if( getZBuffer_Engine( engine ) ) {
		process_task( engine, &(Task) {
			.f = (taskfptr)clearZbufF_Engine,
			.arg = &args->clearZ
		});
	}
	process_task( engine, &(Task) {
		.f = (taskfptr)clearColorbufF_Engine,
		.arg = &args->clearColor
	});

}
